## vtk-dicom 0.5.3

=== CMakeLists.txt ===
project(DICOM)

# CMake version requirements
cmake_minimum_required(VERSION 2.6.3)

# Use LINK_INTERFACE_LIBRARIES instead of INTERFACE_LINK_LIBRARIES
if(POLICY CMP0022)
  cmake_policy(SET CMP0022 OLD)
endif()

# When CMake 3.0.0 is required, remove this block (see CMP0042).
if(NOT DEFINED CMAKE_MACOSX_RPATH)
  set(CMAKE_MACOSX_RPATH 0)
endif()

# Allow custom cmake overrides
set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/CMake" ${CMAKE_MODULE_PATH})

# Use ctest for dashboard submissions
include(CTest)

# Look for a VTK build directory
find_package(VTK REQUIRED)
if(VTK_FOUND)
  include(${VTK_USE_FILE})
  if("${VTK_MAJOR_VERSION}.${VTK_MINOR_VERSION}" VERSION_LESS 5.8)
    message(FATAL_ERROR "VTK 5.8 or later is required.")
  endif()
  # Check if VTK set VTK_ZLIB_LIBRARIES
  if(NOT VTK_ZLIB_LIBRARIES)
    # VTK 6 doesn't set it, so search for vtkzlib directly
    list(FIND VTK_LIBRARIES vtkzlib TMP_INDEX)
    if(TMP_INDEX GREATER -1)
      set(VTK_ZLIB_LIBRARIES vtkzlib)
    endif()
  endif()
  set(DICOM_USE_VTKZLIB OFF)
  if(VTK_ZLIB_LIBRARIES)
    set(DICOM_USE_VTKZLIB ON)
    set(ZLIB_LIBS ${VTK_ZLIB_LIBRARIES})
  endif()
endif()

# Look for zlib
if(NOT DICOM_USE_VTKZLIB)
  find_package(ZLIB REQUIRED)
  if(ZLIB_FOUND)
    set(ZLIB_LIBS ${ZLIB_LIBRARIES})
    include_directories("${ZLIB_INCLUDE_DIR}")
  endif()
endif()

# GDCM or DCMTK are required for reading compressed DICOM images
option(USE_GDCM "Use GDCM for image decompression" OFF)
if(USE_GDCM)
  find_package(GDCM)
  if(NOT GDCM_DIR)
    message(FATAL_ERROR "Please set GDCM_DIR.")
  endif()
  if(GDCM_FOUND)
    include(${GDCM_USE_FILE})
    set(GDCM_LIBS gdcmMSFF gdcmIOD gdcmDSED gdcmDICT)
  endif()
endif()

option(USE_DCMTK "Use DCMTK for image decompression" OFF)
set(DCMTK_LIBS)
if(USE_DCMTK)
  find_package(DCMTK)
  if(NOT DCMTK_FOUND)
    message(FATAL_ERROR "DCMTK not found or incomplete.")
  endif()
  set(DCMTK_LIBS ${DCMTK_LIBRARIES})
  include_directories(${DCMTK_INCLUDE_DIRS})
endif()

option(REMOVE_DEPRECATED_METHODS "Remove deprecated methods from source." ON)

# Project version
set(DICOM_MAJOR_VERSION 0)
set(DICOM_MINOR_VERSION 5)
set(DICOM_BUILD_VERSION 3)
set(DICOM_SHORT_VERSION "${DICOM_MAJOR_VERSION}.${DICOM_MINOR_VERSION}")
set(DICOM_VERSION "${DICOM_SHORT_VERSION}.${DICOM_BUILD_VERSION}")

# Choose static or shared libraries.
option(BUILD_SHARED_LIBS "Build shared libraries." OFF)

# Which parts of the package to build
option(BUILD_PROGRAMS "Build some useful DICOM tools" ON)
option(BUILD_TESTING "Build the tests" ON)
option(BUILD_EXAMPLES "Build the examples" ON)

if(VTK_WRAP_PYTHON)
  option(BUILD_PYTHON_WRAPPERS "Build python wrappers" ON)
else()
  unset(BUILD_PYTHON_WRAPPERS CACHE)
endif()

if(VTK_WRAP_JAVA)
  option(BUILD_JAVA_WRAPPERS "Build java wrappers" OFF)
else()
  unset(BUILD_JAVA_WRAPPERS CACHE)
endif()

# Store the git hash of the current head
if(EXISTS "${DICOM_SOURCE_DIR}/.git/HEAD")
  file(READ "${DICOM_SOURCE_DIR}/.git/HEAD" DICOM_SOURCE_VERSION)
  if("${DICOM_SOURCE_VERSION}" MATCHES "^ref:")
    string(REGEX REPLACE "^ref: *([^ \n\r]*).*" "\\1"
      DICOM_GIT_REF "${DICOM_SOURCE_VERSION}")
    file(READ "${DICOM_SOURCE_DIR}/.git/${DICOM_GIT_REF}"
      DICOM_SOURCE_VERSION)
  endif()
  string(STRIP "${DICOM_SOURCE_VERSION}" DICOM_SOURCE_VERSION)
endif()

# Store the build date
if(WIN32)
#  execute_process(COMMAND "cmd" " /c date /t" OUTPUT_VARIABLE DATE)
#  string(REGEX REPLACE "[^0-9]*(..).*" "\\1" MONTH "${DATE}")
#  set(MONTHS ""
#    "Jan" "Feb" "Mar" "Apr" "May" "Jun" "Jul" "Aug" "Sep" "Oct" "Nov" "Dec")
#  list(GET MONTHS "${MONTH}" MONTH)
#  string(REGEX REPLACE "[^/]*/(..)/(....).*" "\\1 ${MONTH} \\2"
#    DICOM_BUILD_DATE "${DATE}")
#  execute_process(COMMAND "cmd" " /c echo %TIME%" OUTPUT_VARIABLE TIME)
#  string(REGEX REPLACE "[^0-9]*(..:..:..).*" "\\1"
#    DICOM_BUILD_TIME "${TIME}")
else()
  execute_process(COMMAND "date" "+%d %b %Y/%H:%M:%S"
    OUTPUT_VARIABLE DATE_TIME)
  string(REGEX REPLACE "([^/]*)/.*" "\\1"
    DICOM_BUILD_DATE "${DATE_TIME}")
  string(REGEX REPLACE "[^/]*/([0-9:]*).*" "\\1"
    DICOM_BUILD_TIME "${DATE_TIME}")
endif()

# Set up our directory structure for output libraries and binaries
# (Note: these are the build locations, not the install locations)
if(NOT CMAKE_RUNTIME_OUTPUT_DIRECTORY)
  set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${DICOM_BINARY_DIR}/bin")
endif()
if(NOT CMAKE_LIBRARY_OUTPUT_DIRECTORY)
  if(UNIX)
    set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${DICOM_BINARY_DIR}/lib")
  else()
    set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${DICOM_BINARY_DIR}/bin")
  endif()
endif()
if(NOT CMAKE_ARCHIVE_OUTPUT_DIRECTORY)
  set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY "${DICOM_BINARY_DIR}/lib")
endif()

# Set up our target directory structure for "make install"
set(DICOM_BIN_DIR "/bin") # for executables and ".dll" libraries
if(NOT DICOM_LIB_DIR)
  set(DICOM_LIB_DIR "/lib") # for unix/linux/osx shared libraries
endif()
if(NOT DICOM_ARC_DIR)
  set(DICOM_ARC_DIR "${DICOM_LIB_DIR}") # for static or ".lib" libraries
endif()
if(NOT DICOM_INC_DIR)
  set(DICOM_INC_DIR "/include") # for header files
endif()
if(NOT DICOM_JAVA_DIR)
  set(DICOM_JAVA_DIR "/share/java")
endif()
if(NOT DICOM_DATA_DIR)
  set(DICOM_DATA_DIR "/share/dicom-${DICOM_SHORT_VERSION}")
endif()
if(NOT DICOM_CMAKE_DIR)
  set(DICOM_CMAKE_DIR "${DICOM_LIB_DIR}/dicom-${DICOM_SHORT_VERSION}/cmake")
endif()

# Set the full paths to the install tree
set(DICOM_RUNTIME_INSTALL_DEST ${CMAKE_INSTALL_PREFIX}${DICOM_BIN_DIR})
set(DICOM_LIBRARY_INSTALL_DEST ${CMAKE_INSTALL_PREFIX}${DICOM_LIB_DIR})
set(DICOM_ARCHIVE_INSTALL_DEST ${CMAKE_INSTALL_PREFIX}${DICOM_ARC_DIR})
set(DICOM_INCLUDE_INSTALL_DEST ${CMAKE_INSTALL_PREFIX}${DICOM_INC_DIR})
set(DICOM_JAVA_INSTALL_DEST ${CMAKE_INSTALL_PREFIX}${DICOM_JAVA_DIR})
set(DICOM_DATA_INSTALL_DEST ${CMAKE_INSTALL_PREFIX}${DICOM_DATA_DIR})
set(DICOM_CMAKE_INSTALL_DEST ${CMAKE_INSTALL_PREFIX}${DICOM_CMAKE_DIR})

# Configuration header
set(DICOM_BUILD_SHARED_LIBS ${BUILD_SHARED_LIBS})
set(DICOM_BUILD_TESTING ${BUILD_TESTING})
set(DICOM_USE_GDCM ${USE_GDCM})
set(DICOM_USE_DCMTK ${USE_DCMTK})
configure_file(CMake/vtkDICOMConfig.h.in
  "${DICOM_BINARY_DIR}/vtkDICOMConfig.h" @ONLY)
configure_file(CMake/vtkDICOMBuild.h.in
  "${DICOM_BINARY_DIR}/vtkDICOMBuild.h" @ONLY)

# Include directories
set(DICOM_INCLUDE_DIRS "${DICOM_SOURCE_DIR}" "${DICOM_BINARY_DIR}")
include_directories(${DICOM_INCLUDE_DIRS})
set(VTK_WRAP_INCLUDE_DIRS ${DICOM_INCLUDE_DIRS} ${VTK_WRAP_INCLUDE_DIRS})

# Disable C and C++ deprecation warnings for MSVC 2005 and later
if(MSVC_VERSION EQUAL 1400 OR MSVC_VERSION GREATER 1400 OR MSVC10)
  add_definitions(-D_CRT_SECURE_NO_DEPRECATE -D_CRT_NONSTDC_NO_DEPRECATE
                  -D_CRT_SECURE_NO_WARNINGS)
  add_definitions(-D_SCL_SECURE_NO_DEPRECATE -D_SCL_SECURE_NO_WARNINGS)
endif()

# Create the main library
set(LIB_NAME vtkDICOM)

# The library dependencies
set(KWSYS_LIBS vtksys)
if("${VTK_MAJOR_VERSION}" GREATER 5)
  set(VTK_LIBS vtkCommonCore vtkCommonDataModel vtkIOImage) # VTK 6.x
  # If vtkIOMPIImage is present, it has factories for vtkIOImage
  list(FIND VTK_LIBRARIES vtkIOMPIImage TMP_INDEX)
  if(TMP_INDEX GREATER -1)
    set(VTK_LIBS ${VTK_LIBS} vtkIOMPIImage)
  endif()
else()
  set(VTK_LIBS vtkCommon vtkFiltering vtkIO) # VTK 5.x
endif()

if(WIN32)
  set(REFCOUNT_SRC vtkDICOMReferenceCount.cxx)
else()
  set(REFCOUNT_HDR vtkDICOMReferenceCount.h)
endif()

# Sources in the current directory (library sources only!)
set(LIB_SRCS
  vtkDICOMMetaData.cxx
  vtkDICOMDictionary.cxx
  vtkDICOMFile.cxx
  vtkDICOMTag.cxx
  vtkDICOMTagPath.cxx
  vtkDICOMVR.cxx
  vtkDICOMVM.cxx
  vtkDICOMCharacterSet.cxx
  vtkDICOMDataElement.cxx
  vtkDICOMDictHash.cxx
  vtkDICOMDictEntry.cxx
  vtkDICOMDictPrivate.cxx
  vtkDICOMDirectory.cxx
  vtkDICOMGenerator.cxx
  vtkDICOMImageCodec.cxx
  vtkDICOMSCGenerator.cxx
  vtkDICOMCTGenerator.cxx
  vtkDICOMMRGenerator.cxx
  vtkDICOMParser.cxx
  vtkDICOMCompiler.cxx
  vtkDICOMReader.cxx
  vtkDICOMSequence.cxx
  vtkDICOMItem.cxx
  vtkDICOMSorter.cxx
  ${REFCOUNT_SRC}
  vtkDICOMUtilities.cxx
  vtkDICOMValue.cxx
  vtkDICOMWriter.cxx
  vtkDICOMToRAS.cxx
  vtkNIFTIHeader.cxx
  vtkNIFTIReader.cxx
  vtkNIFTIWriter.cxx
)

# Headers without a matching .cxx file are listed here
set(LIB_HDRS
  vtkDICOMModule.h
  ${REFCOUNT_HDR}
  vtkNIFTIPrivate.h
  ${DICOM_BINARY_DIR}/vtkDICOMConfig.h
)

# Internal headers (not installed)
set(LIB_INTERNAL_HDRS
  ${DICOM_BINARY_DIR}/vtkDICOMBuild.h
)

# Sources that are abstract
set(LIB_ABSTRACT
  vtkDICOMGenerator.cxx
)

# Sources that are not vtkObjects
set(LIB_SPECIAL
  vtkDICOMFile.cxx
  vtkDICOMTag.cxx
  vtkDICOMTagPath.cxx
  vtkDICOMVR.cxx
  vtkDICOMVM.cxx
  vtkDICOMCharacterSet.cxx
  vtkDICOMDictEntry.cxx
  vtkDICOMDictionary.cxx
  vtkDICOMDataElement.cxx
  vtkDICOMImageCodec.cxx
  ${REFCOUNT_SRC}
  vtkDICOMSequence.cxx
  vtkDICOMItem.cxx
  vtkDICOMUtilities.cxx
  vtkDICOMValue.cxx
)

set_source_files_properties(${LIB_SPECIAL} PROPERTIES WRAP_EXCLUDE ON)
set_source_files_properties(${LIB_ABSTRACT} PROPERTIES ABSTRACT ON)

# Automatically find the header for each cxx file
foreach(arg ${LIB_SRCS})
  get_filename_component(src "${arg}" ABSOLUTE)
  string(REGEX REPLACE "\\.(cxx|c|mm|m)$" ".h" hdr "${src}")
  if("${hdr}" MATCHES "\\.h$" AND EXISTS "${hdr}")
    list(APPEND LIB_HDRS "${hdr}")
  endif()
endforeach()

# Create the hierarchy file
if("${VTK_MAJOR_VERSION}" GREATER 5)
  if(BUILD_PYTHON_WRAPPERS OR BUILD_JAVA_WRAPPERS)
    set_source_files_properties(${LIB_SPECIAL} PROPERTIES WRAP_SPECIAL ON)
    set(vtk-module ${LIB_NAME})
    set(MODULE_HIERARCHY_NAME ${LIB_NAME}Hierarchy)
    set(${LIB_NAME}_LINK_DEPENDS ${VTK_LIBS} ${KWSYS_LIBS} ${ZLIB_LIBS})
    include(${CMAKE_CURRENT_SOURCE_DIR}/CMake/vtkWrapHierarchy.cmake)
    vtk_wrap_hierarchy(${MODULE_HIERARCHY_NAME} ${DICOM_BINARY_DIR}
      "${LIB_SRCS}")
    set(KIT_HIERARCHY_FILE ${DICOM_BINARY_DIR}/${MODULE_HIERARCHY_NAME}.txt)
    set(LIB_HIERARCHY_STAMP ${DICOM_BINARY_DIR}/${MODULE_HIERARCHY_NAME}.stamp)
  endif()
endif()

# Set the library name suffix for VTK 6 libraries
set(LIB_NAME_SUFFIX "-${VTK_MAJOR_VERSION}.${VTK_MINOR_VERSION}")
if(DEFINED VTK_CUSTOM_LIBRARY_SUFFIX)
  set(LIB_NAME_SUFFIX "${VTK_CUSTOM_LIBRARY_SUFFIX}")
endif()

# Create the library
add_library(${LIB_NAME} ${LIB_SRCS} ${LIB_HIERARCHY_STAMP})
if("${VTK_MAJOR_VERSION}" GREATER 5)
  set_target_properties(${LIB_NAME} PROPERTIES
    OUTPUT_NAME ${LIB_NAME}${LIB_NAME_SUFFIX})
endif()
set_target_properties(${LIB_NAME} PROPERTIES
  VERSION "${DICOM_VERSION}" SOVERSION "${DICOM_SHORT_VERSION}")
if(BUILD_PYTHON_WRAPPERS OR BUILD_JAVA_WRAPPERS AND
   NOT (CMAKE_VERSION VERSION_LESS 2.8))
  set_target_properties(${LIB_NAME} PROPERTIES POSITION_INDEPENDENT_CODE ON)
endif()
target_link_libraries(${LIB_NAME} ${VTK_LIBS} ${KWSYS_LIBS} ${ZLIB_LIBS}
  ${GDCM_LIBS} ${DCMTK_LIBS})
if(BUILD_SHARED_LIBS)
  target_link_libraries(${LIB_NAME} LINK_INTERFACE_LIBRARIES ${VTK_LIBS})
endif()
set(DICOM_LIBRARIES ${LIB_NAME})

# Wrappers
if(BUILD_PYTHON_WRAPPERS)
  set(vtk-module ${LIB_NAME})
  set(XY) # Get python version, e.g. 27 for python 2.7
  if(vtkPython_LIBRARIES)
    list(GET vtkPython_LIBRARIES 0 TMP_LIB_NAME)
    get_filename_component(TMP_NAME "${TMP_LIB_NAME}" NAME)
    string(REGEX REPLACE "^[^0-9]*([0-9])\\.*([0-9]).*$" "\\1\\2"
      XY "${TMP_NAME}")
    if(NOT XY)
      set(XY)
    endif()
  endif()
  set(MODULE_PYTHON_NAME ${LIB_NAME}Python)
  set(LIB_PYTHON_NAME ${LIB_NAME}PythonD)
  set(LIB_PYTHON_OUTPUT_NAME ${LIB_NAME}Python${XY}D)
  if("${VTK_MAJOR_VERSION}" GREATER 5)
    set(LIB_PYTHON_OUTPUT_NAME ${LIB_PYTHON_OUTPUT_NAME}${LIB_NAME_SUFFIX})
  endif()
  set(LIB_PYTHON_LIBS vtkPythonCore)
  if("${VTK_MAJOR_VERSION}" GREATER 5)
    set(LIB_PYTHON_LIBS vtkWrappingPythonCore)
  endif()
  foreach(TMP_LIB ${VTK_LIBS})
    set(LIB_PYTHON_LIBS ${LIB_PYTHON_LIBS} ${TMP_LIB}PythonD)
  endforeach()

  if(VTK_PYTHON_INCLUDE_DIR)
    include_directories("${VTK_PYTHON_INCLUDE_DIR}")
  endif()

=== Programs/CMakeLists.txt ===
include_directories(${DICOM_INCLUDE_DIRS})

set(PROGRAM_SRCS
  dicomdump.cxx
  dicomtonifti.cxx
  niftitodicom.cxx
  niftidump.cxx
)

if("${VTK_MAJOR_VERSION}" GREATER 5)
  set(VTK_IMAGING_LIBS vtkImagingStatistics) # VTK 6.x
else()
  set(VTK_IMAGING_LIBS vtkImaging) # VTK 5.x
endif()

set(BASE_LIBS vtkDICOM ${VTK_LIBS})
if(USE_DCMTK AND DCMTK_charls_LIBRARY)
 set(BASE_LIBS ${BASE_LIBS} ${DCMTK_charls_LIBRARY})
endif()

foreach(src ${PROGRAM_SRCS})
  string(REGEX REPLACE "\\.(cxx|c|mm|m)$" "" prog ${src})
  add_executable(${prog} ${src})
  target_link_libraries(${prog} ${BASE_LIBS}
    ${VTK_IMAGING_LIBS} ${KWSYS_LIBS})
  list(APPEND PROGRAM_EXES ${prog})
endforeach()

install(TARGETS ${PROGRAM_EXES}
  EXPORT DICOMTargets
  RUNTIME DESTINATION ${DICOM_RUNTIME_INSTALL_DEST} COMPONENT RuntimeLibraries
  LIBRARY DESTINATION ${DICOM_LIBRARY_INSTALL_DEST} COMPONENT RuntimeLibraries
  ARCHIVE DESTINATION ${DICOM_ARCHIVE_INSTALL_DEST} COMPONENT Development)

=== debian/changelog ===
vtk-dicom (0.5.3-1) unstable; urgency=low

  * New upstream. Closes: #755011

 -- Mathieu Malaterre <malat@debian.org>  Tue, 29 Jul 2014 14:07:06 +0200

vtk-dicom (0.5.2-1) unstable; urgency=low

  * New upstream
  * Remove patches applied upstream
    - debian/patches/underlink.patch
    - debian/patches/current.patch

 -- Mathieu Malaterre <malat@debian.org>  Tue, 15 Jul 2014 16:52:31 +0200

vtk-dicom (0.5.0-2) unstable; urgency=low

  * Add missing Conflicts/Replaces. Closes: #753467
  * Add Multi-Arch: same when missing
  * Remove local patches, applied upstream. Import from upstream.

 -- Mathieu Malaterre <malat@debian.org>  Fri, 04 Jul 2014 10:45:41 +0200

vtk-dicom (0.5.0-1) unstable; urgency=low

  * New upstream
  * Remove DCMTK option. Closes: #751222
  * Build Python and Java bindings. Closes: #752097

 -- Mathieu Malaterre <malat@debian.org>  Mon, 30 Jun 2014 12:38:00 +0200

vtk-dicom (0.4.5-1) unstable; urgency=low

  * New upstream. Remove patch applied upstream.
  * Really fix man page generation
  * Allow easier backport to wheezy
  * Remove lintian errors/warnings

 -- Mathieu Malaterre <malat@debian.org>  Fri, 25 Apr 2014 17:52:06 +0200

vtk-dicom (0.4.4-2) unstable; urgency=low

  * Add patch to allow backport to wheezy
  * Change to DebianMed uploaders
  * Properly set minimum vtk version
  * Use xz compression
  * Fix man pages generation

 -- Mathieu Malaterre <malat@debian.org>  Mon, 07 Apr 2014 11:55:21 +0200

vtk-dicom (0.4.4-1) unstable; urgency=low

  * New upstream.
    - remove patch applied upstream: d/p/missingstuff.patch
  * Upload to sid not that ABI is stable.

 -- Mathieu Malaterre <malat@debian.org>  Fri, 04 Apr 2014 17:19:25 +0200

vtk-dicom (0.4.3-1) experimental; urgency=low

  * Initial release. (Closes: #742217)

 -- Mathieu Malaterre <malat@debian.org>  Mon, 24 Mar 2014 12:01:00 +0100

=== debian/rules ===
#!/usr/bin/make -f
# export DH_VERBOSE=1

export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

# cannot use ABI mecanism for now:
# https://github.com/dgobbi/vtk-dicom/issues/20
#export DEB_CFLAGS_MAINT_APPEND = -fvisibility=hidden -fvisibility-inlines-hidden
#export DEB_CXXFLAGS_MAINT_APPEND = -fvisibility=hidden -fvisibility-inlines-hidden

# to please dpkg-shlibdeps and java private libs in /usr/lib/jni
LD_LIBRARY_PATH:=$(LD_LIBRARY_PATH):/usr/lib/jni
export LD_LIBRARY_PATH

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

%:
	dh $@ --with python2 --with javahelper --parallel

SOVERSION=0.5
# https://github.com/dgobbi/vtk-dicom/issues/19
#	-DDICOM_INC_DIR:STRING=/include/vtk-dicom-$(SOVERSION)
CMAKE_EXTRA_FLAGS += \
	-DCMAKE_SKIP_RPATH=OFF \
	-DDICOM_LIB_DIR:STRING=/lib/$(DEB_HOST_MULTIARCH) \
	-DCMAKE_BUILD_TYPE:STRING=None \
	-DBUILD_PYTHON_WRAPPERS:BOOL=ON \
	-DBUILD_JAVA_WRAPPERS:BOOL=ON \
	-DUSE_DCMTK:BOOL=OFF \
	-DUSE_GDCM:BOOL=ON \
	-DBUILD_SHARED_LIBS:BOOL=ON

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_EXTRA_FLAGS)

VERSION=$(shell dpkg-parsechangelog | grep '^Version' | cut -d' ' -f2 | cut -f1 -d- | cut -f2 -d~)
pkg_lib = libvtk-dicom$(SOVERSION)
pkg_dev = libvtk-dicom$(SOVERSION)-dev
pkg_bin = vtk-dicom-tools
pkg_py2 = python-vtk-dicom
pkg_java = libvtk-dicom-java

PYVER    := $(shell pyversions -dv)

override_dh_install:
	# bin
	dh_install -p$(pkg_bin) --autodest usr/bin
	# lib
	dh_install -p$(pkg_lib) --autodest usr/lib/$(DEB_HOST_MULTIARCH)/libvtkDICOM.so.*
	# dev:
	dh_install -p$(pkg_dev) --autodest usr/lib/$(DEB_HOST_MULTIARCH)/libvtkDICOM.so
	dh_install -p$(pkg_dev) --autodest usr/lib/$(DEB_HOST_MULTIARCH)/dicom-0.5/cmake/*.cmake
	dh_install -p$(pkg_dev) --autodest usr/include/
	# python2
	dh_install -p$(pkg_py2) --autodest usr/lib/$(DEB_HOST_MULTIARCH)/libvtkDICOMPythonD.so*
	dh_install -p$(pkg_py2) usr/lib/$(DEB_HOST_MULTIARCH)/vtkDICOMPython.so usr/lib/python$(PYVER)/dist-packages
	# java
	dh_install -p$(pkg_java) usr/lib/$(DEB_HOST_MULTIARCH)/libvtkDICOMJava.so usr/lib/jni/$(DEB_HOST_MULTIARCH)
	dh_install -p$(pkg_java) --autodest usr/share/java/vtkdicom.jar
	dh_install --list-missing

debian/%.1: debian/common.1.in
	help2man --help-option=--help --include=$< --version-option=--version --version-string=$(VERSION) \
    --output=$@ --no-info --name="vtk-dicom CLI" ./obj-*/bin/`basename $@ .1`

manpages: debian/dicomdump.1 debian/dicomtonifti.1 debian/niftidump.1 debian/niftitodicom.1
	echo "manpages"

override_dh_installman: manpages
	dh_installman -p$(pkg_bin) debian/*.1

override_dh_clean:
	dh_clean debian/*.1

override_dh_lintian:
	echo "$(pkg_lib): package-name-doesnt-match-sonames" > debian/$(pkg_lib).lintian-overrides
	echo "$(pkg_py2): package-name-doesnt-match-sonames" > debian/$(pkg_py2).lintian-overrides
	echo "$(pkg_py2): non-dev-pkg-with-shlib-symlink" >> debian/$(pkg_py2).lintian-overrides
	dh_lintian

get-orig-source:
	uscan --verbose --rename --force-download

## vtk-dicom 0.5.5

=== CMakeLists.txt ===
--- 
+++ 
@@ -79,7 +79,7 @@
 # Project version
 set(DICOM_MAJOR_VERSION 0)
 set(DICOM_MINOR_VERSION 5)
-set(DICOM_BUILD_VERSION 3)
+set(DICOM_BUILD_VERSION 5)
 set(DICOM_SHORT_VERSION "${DICOM_MAJOR_VERSION}.${DICOM_MINOR_VERSION}")
 set(DICOM_VERSION "${DICOM_SHORT_VERSION}.${DICOM_BUILD_VERSION}")
 
@@ -210,14 +210,14 @@
 # The library dependencies
 set(KWSYS_LIBS vtksys)
 if("${VTK_MAJOR_VERSION}" GREATER 5)
-  set(VTK_LIBS vtkCommonCore vtkCommonDataModel vtkIOImage) # VTK 6.x
+  set(VTK_LIBS vtkCommonCore vtkCommonDataModel vtkImagingCore vtkIOImage)
   # If vtkIOMPIImage is present, it has factories for vtkIOImage
   list(FIND VTK_LIBRARIES vtkIOMPIImage TMP_INDEX)
   if(TMP_INDEX GREATER -1)
     set(VTK_LIBS ${VTK_LIBS} vtkIOMPIImage)
   endif()
 else()
-  set(VTK_LIBS vtkCommon vtkFiltering vtkIO) # VTK 5.x
+  set(VTK_LIBS vtkCommon vtkFiltering vtkImaging vtkIO) # VTK 5.x
 endif()
 
 if(WIN32)
@@ -257,6 +257,8 @@
   vtkDICOMValue.cxx
   vtkDICOMWriter.cxx
   vtkDICOMToRAS.cxx
+  vtkDICOMCTRectifier.cxx
+  vtkDICOMMetaDataAdapter.cxx
   vtkNIFTIHeader.cxx
   vtkNIFTIReader.cxx
   vtkNIFTIWriter.cxx
@@ -297,6 +299,7 @@
   vtkDICOMItem.cxx
   vtkDICOMUtilities.cxx
   vtkDICOMValue.cxx
+  vtkDICOMMetaDataAdapter.cxx
 )
 
 set_source_files_properties(${LIB_SPECIAL} PROPERTIES WRAP_EXCLUDE ON)
@@ -378,6 +381,3 @@
     set(LIB_PYTHON_LIBS ${LIB_PYTHON_LIBS} ${TMP_LIB}PythonD)
   endforeach()
 
-  if(VTK_PYTHON_INCLUDE_DIR)
-    include_directories("${VTK_PYTHON_INCLUDE_DIR}")
-  endif()

=== DicomCli/CMakeLists.txt ===
include_directories(${DICOM_INCLUDE_DIRS})

set(LIB_NAME dicomcli)

set(LIB_SRCS
  readquery.cxx
)

add_library(${LIB_NAME} STATIC ${LIB_SRCS})
target_link_libraries(${LIB_NAME} vtkDICOM)

=== Examples/CMakeLists.txt ===
include_directories(${DICOM_INCLUDE_DIRS})

if("${VTK_MAJOR_VERSION}" GREATER 5)
  set(VTK_RENDERING_LIBS vtkRenderingImage vtkInteractionStyle
      vtkRenderingOpenGL vtkRenderingFreeTypeOpenGL) # VTK 6.x
else()
  set(VTK_RENDERING_LIBS vtkRendering) # VTK 5.x
endif()

set(BASE_LIBS vtkDICOM ${VTK_LIBS})
if(USE_DCMTK AND DCMTK_charls_LIBRARY)
 set(BASE_LIBS ${BASE_LIBS} ${DCMTK_charls_LIBRARY})
endif()

add_executable(TestDICOMCompiler TestDICOMCompiler.cxx)
target_link_libraries(TestDICOMCompiler ${BASE_LIBS} ${KWSYS_LIBS})

add_executable(TestDICOMDirectory TestDICOMDirectory.cxx)
target_link_libraries(TestDICOMDirectory ${BASE_LIBS})

add_executable(TestDICOMParser TestDICOMParser.cxx)
target_link_libraries(TestDICOMParser ${BASE_LIBS})

add_executable(TestDICOMSorter TestDICOMSorter.cxx)
target_link_libraries(TestDICOMSorter ${BASE_LIBS})

add_executable(TestDICOMReader TestDICOMReader.cxx)
target_link_libraries(TestDICOMReader ${BASE_LIBS})

add_executable(TestDICOMWriter TestDICOMWriter.cxx)
target_link_libraries(TestDICOMWriter ${BASE_LIBS})

if(VTK_MAJOR_VERSION GREATER 5 OR VTK_MINOR_VERSION GREATER 9)
add_executable(TestDICOMDisplay TestDICOMDisplay.cxx)
target_link_libraries(TestDICOMDisplay ${BASE_LIBS} ${VTK_RENDERING_LIBS})

add_executable(TestNIFTIDisplay TestNIFTIDisplay.cxx)
target_link_libraries(TestNIFTIDisplay ${BASE_LIBS} ${VTK_RENDERING_LIBS})
endif()

=== Programs/CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,13 @@
-include_directories(${DICOM_INCLUDE_DIRS})
+include_directories(
+  ${DICOM_INCLUDE_DIRS}
+  ${DICOM_SOURCE_DIR}/DicomCli
+  ${DICOM_BINARY_DIR}/DicomCli
+)
 
 set(PROGRAM_SRCS
   dicomdump.cxx
+  dicomfind.cxx
+  dicomtodicom.cxx
   dicomtonifti.cxx
   niftitodicom.cxx
   niftidump.cxx
@@ -10,7 +16,7 @@
 if("${VTK_MAJOR_VERSION}" GREATER 5)
   set(VTK_IMAGING_LIBS vtkImagingStatistics) # VTK 6.x
 else()
-  set(VTK_IMAGING_LIBS vtkImaging) # VTK 5.x
+  set(VTK_IMAGING_LIBS) # VTK 5.x
 endif()
 
 set(BASE_LIBS vtkDICOM ${VTK_LIBS})
@@ -18,10 +24,12 @@
  set(BASE_LIBS ${BASE_LIBS} ${DCMTK_charls_LIBRARY})
 endif()
 
+set(CLI_LIBS dicomcli)
+
 foreach(src ${PROGRAM_SRCS})
   string(REGEX REPLACE "\\.(cxx|c|mm|m)$" "" prog ${src})
   add_executable(${prog} ${src})
-  target_link_libraries(${prog} ${BASE_LIBS}
+  target_link_libraries(${prog} ${BASE_LIBS} ${CLI_LIBS}
     ${VTK_IMAGING_LIBS} ${KWSYS_LIBS})
   list(APPEND PROGRAM_EXES ${prog})
 endforeach()

=== Testing/CMakeLists.txt ===
include_directories(${DICOM_INCLUDE_DIRS})

set(BASE_LIBS vtkDICOM ${VTK_LIBS})
if(USE_DCMTK AND DCMTK_charls_LIBRARY)
 set(BASE_LIBS ${BASE_LIBS} ${DCMTK_charls_LIBRARY})
endif()

add_executable(TestDICOMDictionary TestDICOMDictionary.cxx)
target_link_libraries(TestDICOMDictionary ${BASE_LIBS})
get_target_property(pth TestDICOMDictionary RUNTIME_OUTPUT_DIRECTORY)
add_test(TestDICOMDictionary ${pth}/TestDICOMDictionary)

add_executable(TestDICOMVM TestDICOMVM.cxx)
target_link_libraries(TestDICOMVM ${BASE_LIBS})
get_target_property(pth TestDICOMVM RUNTIME_OUTPUT_DIRECTORY)
add_test(TestDICOMVM ${pth}/TestDICOMVM)

add_executable(TestDICOMVR TestDICOMVR.cxx)
target_link_libraries(TestDICOMVR ${BASE_LIBS})
get_target_property(pth TestDICOMVR RUNTIME_OUTPUT_DIRECTORY)
add_test(TestDICOMVR ${pth}/TestDICOMVR)

add_executable(TestDICOMValue TestDICOMValue.cxx)
target_link_libraries(TestDICOMValue ${BASE_LIBS})
get_target_property(pth TestDICOMValue RUNTIME_OUTPUT_DIRECTORY)
add_test(TestDICOMValue ${pth}/TestDICOMValue)

add_executable(TestDICOMSequence TestDICOMSequence.cxx)
target_link_libraries(TestDICOMSequence ${BASE_LIBS})
get_target_property(pth TestDICOMSequence RUNTIME_OUTPUT_DIRECTORY)
add_test(TestDICOMSequence ${pth}/TestDICOMSequence)

add_executable(TestDICOMMetaData TestDICOMMetaData.cxx)
target_link_libraries(TestDICOMMetaData ${BASE_LIBS})
get_target_property(pth TestDICOMMetaData RUNTIME_OUTPUT_DIRECTORY)
add_test(TestDICOMMetaData ${pth}/TestDICOMMetaData)

add_executable(TestDICOMCharacterSet TestDICOMCharacterSet.cxx)
target_link_libraries(TestDICOMCharacterSet ${BASE_LIBS})
get_target_property(pth TestDICOMCharacterSet RUNTIME_OUTPUT_DIRECTORY)
add_test(TestDICOMCharacterSet ${pth}/TestDICOMCharacterSet)

add_executable(TestDICOMUtilities TestDICOMUtilities.cxx)
target_link_libraries(TestDICOMUtilities ${BASE_LIBS})
get_target_property(pth TestDICOMUtilities RUNTIME_OUTPUT_DIRECTORY)
add_test(TestDICOMUtilities ${pth}/TestDICOMUtilities)

if(BUILD_PYTHON_WRAPPERS)
  if(NOT VTK_PYTHON_EXE)
    get_target_property(WRAP_PYTHON_PATH vtkWrapPython LOCATION)
    get_filename_component(VTK_EXE_DIR ${WRAP_PYTHON_PATH} PATH)
    find_program(VTK_PYTHON_EXE vtkpython "${VTK_EXE_DIR}")
  endif()
  if(NOT VTK_PYTHON_EXE)
    # fall back to using python rather than vtkpython
    find_package(PythonInterp QUIET)
    mark_as_advanced(PYTHON_EXECUTABLE)
    set(VTK_PYTHON_EXE ${PYTHON_EXECUTABLE})
  endif()
  add_test(TestDICOMPython "${VTK_PYTHON_EXE}"
    "${CMAKE_CURRENT_SOURCE_DIR}/TestDICOMPython.py")
  if(NOT CMAKE_CONFIGURATION_TYPES)
    set_tests_properties(TestDICOMPython PROPERTIES ENVIRONMENT
      "PYTHONPATH=${CMAKE_LIBRARY_OUTPUT_DIRECTORY}")
  endif()
endif()

if(BUILD_JAVA_WRAPPERS)
  set(_sep ":")
  if(WIN32)
    set(_sep "\\;")
  endif()
  configure_file("${CMAKE_CURRENT_SOURCE_DIR}/TestDICOMJava.java.in"
    "${CMAKE_CURRENT_BINARY_DIR}/TestDICOMJava.java" @ONLY)
  add_custom_command(
    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/javac_test_stamp.txt
    COMMAND ${JAVA_COMPILE} ${JAVAC_OPTIONS}
    -source ${VTK_JAVA_SOURCE_VERSION}
    -target ${VTK_JAVA_TARGET_VERSION}
    -classpath "${VTK_JAR_PATH}/vtkdicom.jar${_sep}${DICOM_BINARY_DIR}/java${_sep}${VTK_JAVA_JAR}"
    -sourcepath ${CMAKE_CURRENT_SOURCE_DIR}
    -d ${CMAKE_CURRENT_BINARY_DIR}
    ${CMAKE_CURRENT_BINARY_DIR}/TestDICOMJava.java
    COMMAND ${CMAKE_COMMAND} -E touch ${CMAKE_CURRENT_BINARY_DIR}/javac_test_stamp.txt
    DEPENDS vtkDICOMJavaJar
    "${CMAKE_CURRENT_BINARY_DIR}/TestDICOMJava.java"
    COMMENT "Compiling Java Tests"
    )
  add_custom_target(DICOMJavaTests ALL DEPENDS
    ${CMAKE_CURRENT_BINARY_DIR}/javac_test_stamp.txt ${JAVA_LIBRARIES})
  add_test(TestDICOMJava "${JAVA_RUNTIME}"
    -classpath "${VTK_JAR_PATH}/vtkdicom.jar${_sep}${DICOM_BINARY_DIR}/java${_sep}${VTK_JAVA_JAR}${_sep}${CMAKE_CURRENT_BINARY_DIR}"
    TestDICOMJava)
endif()

=== debian/changelog ===
vtk-dicom (0.5.5-2) unstable; urgency=low

  * Do not link explicitly to libpython. Closes: #762102
  * Do not clutter jar file with java source code. Closes: #762112

 -- Mathieu Malaterre <malat@debian.org>  Wed, 24 Sep 2014 14:17:38 +0200

vtk-dicom (0.5.5-1) unstable; urgency=low

  * New upstream
    - add missing man pages (dicomfind/dicomtodicom)

 -- Mathieu Malaterre <malat@debian.org>  Thu, 28 Aug 2014 13:24:50 +0200

=== debian/control ===
Source: vtk-dicom
Section: graphics
Priority: optional
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Mathieu Malaterre <malat@debian.org>
Build-Depends: cmake (>= 2.6.3),
               debhelper (>= 9),
               default-jdk,
               help2man,
               javahelper,
               libgdcm2-dev,
               libvtk-java,
               libvtk5-dev (>= 5.8),
               python-all-dev,
               python-vtk
Homepage: http://github.com/dgobbi/vtk-dicom/
Vcs-Browser: http://anonscm.debian.org/viewvc/debian-med/trunk/packages/vtk-dicom/trunk/
Vcs-Svn: svn://anonscm.debian.org/debian-med/trunk/packages/vtk-dicom/trunk
Standards-Version: 3.9.5
X-Python-Version: 2.7

Package: libvtk-dicom0.5-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: libvtk-dicom0.5 (= ${binary:Version}), ${misc:Depends}
Replaces: libvtk-dicom0.4-dev
Conflicts: libvtk-dicom0.4-dev
Provides: libvtk-dicom-dev
Description: DICOM for VTK - dev
 This package contains a set of classes for managing DICOM
 files and metadata from within VTK, and some utility programs
 for interrogating and converting DICOM files.
 .
 Development headers

Package: libvtk-dicom0.5
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: DICOM for VTK - lib
 This package contains a set of classes for managing DICOM
 files and metadata from within VTK, and some utility programs
 for interrogating and converting DICOM files.
 .
 Libraries for runtime applications

Package: vtk-dicom-tools
Section: utils
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: DICOM for VTK - tools
 This package contains a set of classes for managing DICOM
 files and metadata from within VTK, and some utility programs
 for interrogating and converting DICOM files.
 .
 Command line tools

Package: libvtk-dicom-java
Section: java
Architecture: any
Depends: ${java:Depends}, ${misc:Depends}, ${shlibs:Depends}
Suggests: java-virtual-machine
Description: DICOM for VTK - java
 This package contains a set of classes for managing DICOM
 files and metadata from within VTK, and some utility programs
 for interrogating and converting DICOM files.
 .
 Java 1.5 bindings

Package: python-vtk-dicom
Section: python
Architecture: any
Depends: ${misc:Depends}, ${python:Depends}, ${shlibs:Depends}
Provides: ${python:Provides}
Description: DICOM for VTK - python
 This package contains a set of classes for managing DICOM
 files and metadata from within VTK, and some utility programs
 for interrogating and converting DICOM files.
 .
 Python 2.x bindings

=== debian/rules ===
--- 
+++ 
@@ -55,7 +55,7 @@
 	dh_install -p$(pkg_py2) --autodest usr/lib/$(DEB_HOST_MULTIARCH)/libvtkDICOMPythonD.so*
 	dh_install -p$(pkg_py2) usr/lib/$(DEB_HOST_MULTIARCH)/vtkDICOMPython.so usr/lib/python$(PYVER)/dist-packages
 	# java
-	dh_install -p$(pkg_java) usr/lib/$(DEB_HOST_MULTIARCH)/libvtkDICOMJava.so usr/lib/jni/$(DEB_HOST_MULTIARCH)
+	dh_install -p$(pkg_java) usr/lib/$(DEB_HOST_MULTIARCH)/libvtkDICOMJava.so usr/lib/$(DEB_HOST_MULTIARCH)/jni
 	dh_install -p$(pkg_java) --autodest usr/share/java/vtkdicom.jar
 	dh_install --list-missing
 
@@ -63,7 +63,7 @@
 	help2man --help-option=--help --include=$< --version-option=--version --version-string=$(VERSION) \
     --output=$@ --no-info --name="vtk-dicom CLI" ./obj-*/bin/`basename $@ .1`
 
-manpages: debian/dicomdump.1 debian/dicomtonifti.1 debian/niftidump.1 debian/niftitodicom.1
+manpages: debian/dicomdump.1 debian/dicomtonifti.1 debian/niftidump.1 debian/niftitodicom.1 debian/dicomfind.1 debian/dicomtodicom.1
 	echo "manpages"
 
 override_dh_installman: manpages
